<?php

/**
 * @file
 * Page callbacks for gridstack module.
 */

/**
 * Callback for loading nodes.
 */
function gridstack_field_node_callback($node, $display = 'teaser') {
  if ($node->status == 0) {
    drupal_add_http_header('Status', '404 Not Found');
    drupal_fast_404();
  }
  $node_for_displaying = node_view($node, $display);

  return print render($node_for_displaying);
}

/**
 * Callback for autocomplete field.
 */
function gridstack_field_autocomplete_callback($field_name, $string) {
  // Using check functions on output to prevent cross site scripting attacks.
  $field_name = check_plain($field_name);
  $string = check_plain($string);

  $field = field_info_field($field_name);

  // Get array of content types from field settings.
  $type = array_filter($field['settings'], function ($v) {
    return $v === 1;
  });
  $type = array_keys($type);

  if (!empty($type)) {
    $matches = array();
    $res = db_select('node', 'n');
    $res->fields('n', array('title', 'nid', 'type'));
    $res->condition('title', '%' . db_like($string) . '%', 'LIKE');
    $res->condition('type', $type, 'IN');
    $res->range(0, 10);
    $query = $res->execute()->fetchAll();
    foreach ($query as $row) {
      $matches[$row->nid] = $row->title . '  [' . $row->type . ']';
    }
    // Return the result to the form in json.
    drupal_json_output($matches);
  }
}
